<?php

class SurveyRDFReader
{
	var $model;
		
	public function SurveyRDFReader()
	{
        // Create empty MemModel
		$factory = new ModelFactory();
		$this->model = $factory->getDefaultModel();	
	}
	
	public function loadSurvey($sTitle)
	{
		$this->model->load('surveys/'.$sTitle.'.rdf');
	}
	
	public function readSurveyTitle()
	{
		$querystring = '
			PREFIX 	predicates: <' .SURVEYTOOL_PREDICATES_NAMESPACE . '>
			PREFIX	resources: <' . SURVEYTOOL_RESOURCES_NAMESPACE . '>
			SELECT 	?title
			WHERE 	{ resources:survey predicates:title ?title }';
			
		$result = $this->model->sparqlQuery($querystring);
		
		return $result;
	}
	
	public function readSurveyDescription()
	{
		$querystring = '
			PREFIX 	predicates: <' .SURVEYTOOL_PREDICATES_NAMESPACE . '>
			PREFIX	resources: <' . SURVEYTOOL_RESOURCES_NAMESPACE . '>
			SELECT 	?description 
			WHERE 	{ resources:survey predicates:description ?description }';
			
		$result = $this->model->sparqlQuery($querystring);
		
		return $result;
	}
}

?>
