<?php

class SurveyRDFWriter 
{
	var $model;
		
	var $resourceSurvey;
    /**
    * Use SurveyRDFWriter::getInstance() instead of this
    * constructor.
    */
    public function __construct()
    {
        // Create empty MemModel
		$factory = new ModelFactory();
		$this->model = $factory->getDefaultModel();
		
		$this->initResources();
    }

	function initResources()
	{
		
		$this->resourceSurvey = new Resource(SURVEY);
	}
	
	public function createSurvey($sTitle, $sDescription)
	{		
		
		$predicateTitle = new Resource(TITLE);		
		$surveyTitle = new Literal($sTitle);
		$this->model->add(new Statement($this->resourceSurvey,$predicateTitle,$surveyTitle));		
		
		$predicateDescription = new Resource(DESCRIPTION);
		$surveyDescription = new Literal($sDescription);
		$this->model->add(new Statement($this->resourceSurvey,$predicateDescription,$surveyDescription));		
	}
	
	public function addQuestion($qTitle,$qDescription,$qType,$qAnswers)
	{
		$resourceQuestion = new Resource(QUESTION);
		$predicateQuestion = new Resource(HAS_QUESTION);
		$this->model->add(new Statement($this->resourceSurvey,$predicateQuestion,$resourceQuestion));
		
		$predicateTitle = new Resource(TITLE);		
		$questionTitle = new Literal($qTitle);
		$this->model->add(new Statement($resourceQuestion,$predicateTitle,$questionTitle));	
		
		$predicateDescription = new Resource(DESCRIPTION);
		$questionDescription = new Literal($qDescription);
		$this->model->add(new Statement($resourceQuestion,$predicateDescription,$questionDescription));		
		
		$predicateType = new Resource(TYPE);
		$resourceQuestionType = new Resource(QUESTION_TYPE);
		$this->model->add(new Statement($resourceQuestion,$predicateType,$resourceQuestionType));
		
		foreach($qAnswers as $answer)
		{
			$resourceAnswer = new Resource(ANSWER);
			$predicateAnswer = new Resource(HAS_ANSWER);	
			$this->model->add(new Statement($resourceQuestion,$predicateAnswer,$resourceAnswer));
			
			$predicateTitle = new Resource(TITLE);
			$answerTitle = new Literal($answer['Title']);
			$this->model->add(new Statement($resourceAnswer,$predicateTitle,$answerTitle));
			
			$predicateDescription = new Resource(DESCRIPTION);
			$answerDescription = new Literal($answer['Description']);
			$this->model->add(new Statement($resourceAnswer,$predicateDescription,$answerDescription));
			
		}
		
		
	}
	
	public function saveSurvey($sTitle)
	{
		$this->model->saveAs('surveys/'.$sTitle.'.rdf','rdf');
		
		return true;
	}

}

?>